#ifndef _EVENT_H_
#define _EVENT_H_
/*This file contains the definitions for the PQE and the eventlist 
classes*/
#include "link.h"
#include "event.h"
#include "struct_h.h"

class event;  /*see event.h*/
struct PQEnode; /*see struct_h.h*/
class PQE  /* stands for priority queue element, see next class. */
           /* use  ``new'' and  ``delete'' to create these as needed. */
{
public:
double time;     //time at which the event will occur
int type;        //type of the event to which ptr points to
event * ptr;     //pointer to the event pointed at. 

//functions
public:
PQE(double eventtime, int type, event *eventptr); //constructor
/* "eventtime" -> time at which the event occurs
   "type": 0 -> if it is TO event
           1 -> for event: Frame handed from node to buffer
	   2 -> for event: frame handed from buffer to link
           3 -> for event: Frame handed from link to node
   "eventptr" -> is the pointer to the event node
*/
};

class eventlist 
{ 
public:
PQEnode * first; // pointer to first element in the data structure.  

public:

eventlist();  //constructor

PQE *dequeue();
/*removes and returns a PQE node at the head of the eventlist
*/

void enqueue(PQE &);
/*Inserts the passed in PQE node into the eventlist according to 
increasing order of event time */

void destroyeventlist();  //destroys all the events in the eventlist

};

#endif
