/*The file contains the function definitions for the event class */

#include <iostream>
using namespace std;
#include "event.h"

//constructor
event::event()
{
  timeout = false;
}

//Intialize the newly created event node with values for event_time,
//event_type, etc..

void event::scheduleevent(double event_time, frame *frame_ptr, int 
event_type, node *source, node *destn, framebuffer *destbuff, framebuffer 
*sourcebuff, link *source_link, link *dest_link)
{
   time = event_time;

   switch(event_type)
   {
     case 0:        //event for TO
   	sourcetype = Node;
	desttype = Node;
	sourcenode = source;
        destnode = destn;
        sourcebuffer = sourcebuff;
	destbuffer = destbuff;
	sourcelink = source_link; 
	destlink = dest_link;
	thisframe = NULL;
	dataseq = frame_ptr->dataseq;
     case 1:       //frame handed from node to buffer
	sourcetype = Node;
        desttype = Buffer;
        sourcenode = source;
        destnode = destn;
        sourcebuffer = sourcebuff;
        destbuffer = destbuff;
        sourcelink = source_link;
        destlink = dest_link;
        thisframe = frame_ptr;
        dataseq = frame_ptr->dataseq;
     case 2:		//frame handed from buffer to link
	sourcetype = Buffer;
        desttype = Link;
        sourcenode = source;
        destnode = destn;
        sourcebuffer = sourcebuff;
        destbuffer = destbuff;
        sourcelink = source_link;
        destlink = dest_link;
        thisframe = frame_ptr;
        dataseq = frame_ptr->dataseq;
     case 3:
	sourcetype = Link;
        desttype = Node;
        sourcenode = source;
        destnode = destn;
        sourcebuffer = sourcebuff;
        destbuffer = destbuff;
        sourcelink = source_link;
        destlink = dest_link;
        thisframe = frame_ptr;
        dataseq = frame_ptr->dataseq;

   };

}

/***********************************************************************
	Event handler for time out
    Input: Pointer to the event list
           Pointer to the node in which the event occurred
           Pointer to the PQE node of the event
           current time
    Output: None
*************************************************************************/
void event::TO_handler(eventlist *head, node *snode, PQE *PQE_ptr, double 
current_time)
{
  snode->timeout(dataseq, head, snode, PQE_ptr, current_time); 
  
}

/*********************************************************************
 	Event handler for event:frame given from node to buffer
     Input: Pointer to the eventlist
            Pointer to the buffer to which the node is given
            current time
     Output: None
**********************************************************************/
void event::Node2Buff_handler(eventlist* header, framebuffer *sourcebuff, 
double current_time)
{
   sourcebuff->include(thisframe, header, sourcebuff, current_time);
    
   // delete thisframe;
    thisframe = NULL;
}

/*********************************************************************
	Event handler for event:frame given from buffer to link
     Input: Pointer to the event list
            pointer to the link in which the event occurred
            Current time
***********************************************************************/
void event::Buffer2Link_handler(eventlist * neweventlist, link *slink, 
double current_time)
{
  slink->processframe(thisframe, neweventlist, slink, current_time);
  //delete thisframe;
  thisframe = NULL;
}


/************************************************************************
	Event handler for event:frame given from link to node
    Input: Pointer to the node which generated the frame
           Pointer to the node to which the frame is given
           Pointer to the eventlist header
           Current time
    Output: None
***********************************************************************/       
void event::Link2Node_handler(node *source, node *destn,eventlist * 
header, double current_time)
{
 if(thisframe->type == Data)
   destn->receiveframeatdest(thisframe, destn, header, current_time);
 else
   source->receiveframeatsource(thisframe, source, header, current_time);
  delete thisframe;
  thisframe = NULL;
}

