#ifndef _INPUT_H_
#define _INPUT_H_

/***Modify Propagation delay, line speed and other values here ***/

const int HEADER_LENGTH = 320; //Average header length in bits
                               //that is 40 Bytes.
			       
const int DATA_LENGTH = 7680; /*bits. If you change the DATA_LENGTH, make 
				sure to change the DATAFRAME_SIZE 
				correspondlingly */
const int DATAFRAME_SIZE = 8000; //bits: That is 1000 Bytes 
				 //it is HEADER_LENGTH+DATA_LENGTH
const double PL = 0.05;  //loss probability
const double PD = 0.10;  //damage probability
const double POK = 1 - (PL+PD);
const int W = 3;   //number of outstanding frames

const double LINESPEED = 1000000.0;  //in bits/sec: 10Mbits/sec
const double PROP_DELAY = .024;  /*in secs: 24 msec. Make sure it is 
                                   equal to W*(DATAFRAME_SIZE/LINESPEED 
                                 */
const int FINAL_FRAME = 100;  /*It is the stopping condition for the 
			        simulator. When the source node sends this 
                                many number of frames, the simulator will 
				stop */
const double TIMEOUT = 0.06406;  /*Timeout interval of a frame */                                    
#endif
