/* This is the implementation file for the link class */

#include "link.h"
#include <iostream>
#include "constants.h"
using namespace std;

//constructor
link::link(node *next_node)
{
  linespeed = LINESPEED;
  prop_delay = PROP_DELAY;
  pl = PL;
  pd = PD;
  pok = POK;
  nextnode = next_node;
}

double link::randomno()
{
  return (double)rand()/RAND_MAX;
}

//This function processes the frame arrived completely in the link
//Checks for frame loss, damage and generates event:frame arriving at node

void link::processframe(frame *frameinlink, eventlist *head, link 
*sourcelink, double current_time)
{
   double randno = randomno();
   
   if((randno>pok) &&(randno<=(pd+pok))) //packet damaged
   {
    if(frameinlink->type == Data)
      cout<<"\nData frame with sequence number "<<frameinlink->dataseq;
    else if(frameinlink->type == ACK)
      cout<<"\nACK frame for sequence "<<frameinlink->ackseq;
    else
      cout<<"\nNACK frame for expected sequence "<<frameinlink->ackseq;
      cout<<" damaged in link.\n";
      frameinlink->status=damaged;
   }

   if(((randno>pok)&&(randno<=(pd+pok)))||(randno<=pok)) //if 
                                  //damaged or ok
   {
           event * newevent2 = new event();
           double traveltime = prop_delay + current_time;
           newevent2->scheduleevent(traveltime, frameinlink, 3, NULL, 
            nextnode, NULL, NULL, sourcelink, NULL);
           PQE *newPQE1 = new PQE(traveltime, 3, newevent2);
           head->enqueue(*newPQE1);
          
   }
   if((randno>(pok+pd))&&(randno<=1))
   {//delete lost frame in link
     
     if(frameinlink->type == Data)
      cout<<"\nData frame sequence "<<frameinlink->dataseq;
     else if(frameinlink->type == ACK)
      cout<<"\nACK frame for sequence "<<frameinlink->ackseq;
     else
      cout<<"\nNACK frame for expected sequence "<<frameinlink->ackseq;
      cout<<" lost in link.\n";
      delete frameinlink;
      frameinlink = NULL;
   }  
}  
