#ifndef _LINK_H_
#define _LINK_H_
/* The header file contains the definition of the link class */

#include <string>
using namespace std;
#include "frame.h"
#include "event.h"
#include "struct_h.h"
#include "PQE.h"
#include "framebuffer.h"
#include "node.h"
#include "constants.h"
#include "input.h"

class eventlist;  /*see PQE.h*/
class frame;      /* see frame.h*/
class link  /* the transmission links. There are two. */
{
public:
double linespeed ; /* bytes / sec */
double prop_delay ; /* seconds */
node * nextnode ; /* the node to which the link hands frames. */

double pl ;   /*frame loss probability*/
double pd ;   /*frame damage probability */
double pok ;  /*probability that the frame will arrive ok at the destn */

public:
link(node *ptr);  //constructor
/* ptr is the pointer to the node the link hands frames to */

double randomno(); //generates a random number between 0 and 1 
                   //used to determine if frame is lost/damaged/ok

void processframe(frame *arrivedframe,eventlist * ev_list, link* 
receivedlink, double current_time);
/* when a frame arrives in the completely in the link, processframe 
processes the frame to check if it is damaged/ok and creates event:Frame 
handed from link to node
 "arrivedframe" -> pointer to the frame arrived in link
 "ev_list" -> pointer to the eventlist(there is only one eventlist).
 "receivedlink" -> pointer to the link in which the frame arrived
 "current_time" -> time at which the frame arrived in link
*/

};

#endif 


